import os
import time

from spacemit_llm import LLMModel, FCModel
llm_model = LLMModel()
fc_model = FCModel(fc_model_name = 'qwen2.5-0.5b-elephant-fc')

from spacemit_audio import ASRModel, RecAudio
asr_model = ASRModel()
rec_audio = RecAudio(vad_mode=1, sld=1, channels=1, rate=48000, input_device_index=1) # 输入设备索引为1，表示使用USB麦克风; 输入设备索引为0，表示使用HDMI麦克风

from tools.elephant import func_map

if __name__ == '__main__':
    try:
        while True:
            print("Press enter to start!")
            input() # enter 触发
            audio_file = rec_audio.record_audio()
            text = asr_model.generate(audio_file)
            print('user: ', text)

            t1 = time.time()
            function_called, func_name, args = fc_model.get_function_name(text, func_map)
            print('used time:', time.time() - t1)
            if function_called:
                print(f"调用的函数名: {func_name}, 函数参数：{args}")
                continue

            llm_output = llm_model.generate(text)
            for output_text in llm_output:
                print(output_text, end='', flush=True)

    except KeyboardInterrupt:
        print("process was interrupted by user.")
