from spacemit_cv import AGVDetection
import cv2
import argparse
import numpy as np

from spacemit_cv import AGVDetection,DetectionThread
import threading
import queue


def main(args):
   
    result_queue = queue.Queue()
    detection_thread = DetectionThread(result_queue, args.model)
    detection_thread.start()

    try:
        while True:
            if not result_queue.empty():
                closest_center = result_queue.get()
                print(f"最靠近摄像头中心的检测框中心点坐标: {closest_center}")
    except KeyboardInterrupt:
        detection_thread.stop()
  



if __name__ == '__main__':

    # 解析命令行参数
    parser = argparse.ArgumentParser(description='YOLOv8 ONNX Inference')
    parser.add_argument('--model', type=str, default='spacemit_cv/model/yolov8n.q.onnx', help='Path to the YOLOv8 ONNX model')
    args = parser.parse_args()

    main(args)