## 依赖安装

```shell
sudo apt update
sudo apt upgrade
sudo apt install python3-venv
python3 -m venv .venv
source .venv/bin/activate
pip install --index-url https://git.spacemit.com/api/v4/projects/33/packages/pypi/simple opencv-python==4.6.8.1

```

## 执行方法

```shell
# 大象机械臂demo
python cv_robot_arm_demo.py #默认是加载spacemit_cv/yolov8n.q.onnx模型，推理spacemit_cv/test.jpg,可使用--model 和--image 指定模型和图片路径，还有--use-camera来使用摄像头进行推理
# agv小车demo
python cv_agv_demo.py #默认是加载spacemit_cv/yolov8n.q.onnx模型，可使用--model指定模型，只能是调取摄像头的方式

```



## 接口说明

#### 大象机械臂api说明

代码在cv_robot_arm_demo.py中

```python
# 创建基础类
detector = ElephantDetection(模型路径)
# 执行推理
result_image, rect_list = detector.infer() #result_image为画好框的图像，rect_list为[x,y,w,h,class,prob]的列表
```

#### agv小车demo说明

代码在cv_agv_demo.py

```python
# 创建结果队列
result_queue = queue.Queue()
# 创建Detection线程类
detection_thread = DetectionThread(result_queue, args.model)
#启动检测线程
detection_thread.start()
# 获取检测结果，结果为最靠近摄像头中心的框的[左上角，右下角]坐标
closest_center = result_queue.get()
```

